//+------------------------------------------------------------------+
//|                                           CloseOnNetProfitEA.mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
extern bool CloseOnProfit = true;
extern bool LogHiLowToScreen=true;
extern double  CloseAtOrAboveDollarAmt =  50;
extern string Symbol1 = "USDCHF";
extern string Symbol2 = "EURUSD";
extern string BuySell="S";
extern double Lots=1;
extern int MaxSpread=3;
extern double Hi = 0;
extern double Lo = 0;

 int m_intTotOrders =0;
 double m_dblLo = 9999.00;
 double m_dblHi = -9999.00;
 bool m_blnDidOrderClose=true;
 double m_dblDollarAmountofOrders =0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
 // PlaceNewOrders();
 // m_intTotOrders=OrdersTotal();
 // if (Hi != 0) m_dblHi=Hi;
 // if (Lo != 0) m_dblLo=Lo ;
 
 // Comment("High = " + DoubleToStr(m_dblHi,2) + "   "  + "Low = " + DoubleToStr(m_dblLo,2));
//----
   return(0);
  } //int init()
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  Comment("");

   
//----
   return(0);
  }//int deinit()
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
  
    if(OrdersTotal()==0) PlaceNewOrders();  
   if(OrdersTotal() != m_intTotOrders)m_intTotOrders = OrdersTotal();
    int PositionIndex;    //  <-- this variable is the index used for the loop

      int TotalNumberOfOrders;   //  <-- this variable will hold the number of orders currently in the Trade pool

      for(PositionIndex = m_intTotOrders - 1; PositionIndex >= 0 ; PositionIndex --) 
       {
          if( ! OrderSelect(PositionIndex, SELECT_BY_POS, MODE_TRADES) ) continue;
          
          m_dblDollarAmountofOrders=m_dblDollarAmountofOrders+OrderProfit()+
          OrderCommission()+OrderSwap();
      
       }
   
   //chk if greater than user input
   CheckHiLo();
  CheckCloseOnProfit();
   m_dblDollarAmountofOrders=0;
   
//----
   return(0);
 } //int start()

void CheckHiLo()
  {
  
    if (m_dblDollarAmountofOrders < m_dblLo) m_dblLo=m_dblDollarAmountofOrders ;
    if (m_dblDollarAmountofOrders > m_dblHi) m_dblHi=m_dblDollarAmountofOrders ;
   
    
    //chk if user wants to display to screen
    if (LogHiLowToScreen) Comment("High = " + 
    DoubleToStr(m_dblHi,2) + "   "  + "Low = " + 
    DoubleToStr(m_dblLo,2) + "  Profit: " + m_dblDollarAmountofOrders);
        
  }  //void CheckHiLo()

  
void CheckCloseOnProfit()
{
  
  if (CloseOnProfit)
  {
    if (m_dblDollarAmountofOrders >= CloseAtOrAboveDollarAmt)
    {
      m_blnDidOrderClose=true ;
      // close all orders
      int PositionIndex;    //  <-- this variable is the index used for the loop
      int TotalNumberOfOrders;   //  <-- this variable will hold the number of orders currently in the Trade pool
      TotalNumberOfOrders = OrdersTotal();    // <-- we store the number of Orders in the variable
      for(PositionIndex = TotalNumberOfOrders - 1; PositionIndex >= 0 ; PositionIndex --)  //  <-- for loop to loop through all Orders . .   COUNT DOWN TO ZERO !
       {
        if( ! OrderSelect(PositionIndex, SELECT_BY_POS, MODE_TRADES) ) continue;   // <-- if the OrderSelect fails advance the loop to the next PositionIndex
       
   
        if ( ! OrderClose( OrderTicket(), OrderLots(), OrderClosePrice(), 3 ) )  // <-- try to close the order
         {    
          if (m_blnDidOrderClose==false)    
          Print("Order Close failed, order number: ", OrderTicket(), " Error: ", GetLastError() );  // <-- if the Order Close failed print some helpful information 
          return;
         }
            
  
      } //  end of For loop
   
     
     PlaceNewOrders();
   } //if (m_dblDollarAmountofOrders >= CloseAtOrAboveDollarAmt)
   
 }  //if (CloseOnProfit)
} //void CheckCloseOnProfit()
  
  
void PlaceNewOrders()
{
  
    m_intTotOrders =0;
    m_dblLo = 9999.00;
    m_dblHi = -9999.00;
    m_blnDidOrderClose=true;
    m_dblDollarAmountofOrders =0;
    int intTicket = 0;
    RefreshRates();
    //==========Chk for Sells
    if (BuySell=="S")
     {
     
      intTicket=OrderSend(Symbol1,OP_SELL,Lots,Bid,MaxSpread,0,0,0,0,0);
      if (intTicket<0)
      {
        Print("Order Open failed." + Symbol1 + " order number: ", OrderTicket(), " Error: ", GetLastError() );  // <-- if the Order Open failed print some helpful information 
          return;
      
      }
      intTicket=OrderSend(Symbol2,OP_SELL,Lots,Bid,MaxSpread,0,0,0,0,0);
       if (intTicket<0)
      {
        Print("Order Open failed." + Symbol2 + " order number: ", OrderTicket(), " Error: ", GetLastError() );  // <-- if the Order Open failed print some helpful information 
        return;
      
      }
            
    } //  if (BuySell=="S")
    
    //Chk for Buys
     if (BuySell=="B")
     {
     
      intTicket=OrderSend(Symbol1,OP_BUY,Lots,Ask,MaxSpread,0,0,0,0,0);
      if (intTicket<0)
      {
        Print("Order Open failed." + Symbol1 + " order number: ", OrderTicket(), " Error: ", GetLastError() );  // <-- if the Order Open failed print some helpful information 
          return;
      
      }
      intTicket=OrderSend(Symbol2,OP_BUY,Lots,Ask,MaxSpread,0,0,0,0,0);
       if (intTicket<0)
      {
        Print("Order Open failed." + Symbol2 + " order number: ", OrderTicket(), " Error: ", GetLastError() );  // <-- if the Order Open failed print some helpful information 
        return;
      
      }
            
    } //  if (BuySell=="B")
    
    
    
    
    
     m_intTotOrders=OrdersTotal();
     if (Hi != 0) m_dblHi=Hi;
     if (Lo != 0) m_dblLo=Lo ;
 
     Comment("High = " + DoubleToStr(m_dblHi,2) + "   "  + "Low = " + DoubleToStr(m_dblLo,2));
} //void PlaceNewOrders()



//+------------------------------------------------------------------+